<script lang="ts" setup>
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import type { User } from '@/types/User'
import http from '@/services/http'
import { useLoadingStore } from '@/stores/loading'
import type { Member } from '@/types/Member'
import { useMemberStore } from '@/stores/member'
import { useReceiptStore } from '@/stores/receipt'
const memberStore = useMemberStore()
import { useDate } from 'vuetify'
//const date = ref<Date | null>(null);
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
let editedIndex = -1
let lastId = 4
function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    memberStore.clearFrom()
  })
}
async function deleteItemConfirm() {
  // Delete item from list
  closeDelete()
  await memberStore.deleteMember()
}
async function editItem(item: Member) {
  if (!item.id) return
  await memberStore.getMember(item.id)
  dialog.value = true
}
async function deleteItem(item: Member) {
  if (!item.id) return
  await memberStore.getMember(item.id)
  dialogDelete.value = true
  editedIndex = -1
}
function closeDialog() {
  dialog.value = false
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  // const selectedDate = new Date(memberStore.editedMember.birth)
  await memberStore.saveMember()
  closeDialog()
}

onMounted(() => {
  memberStore.getMembers()
})
</script>

<template>
  <v-container>
    <v-toolbar flat>
      <v-toolbar-title>Member</v-toolbar-title>
      <v-divider class="mx-4" inset vertical></v-divider>
      <v-spacer></v-spacer>
      <!-- Put Edited Dialog -->

      <v-dialog v-model="dialog" persistent width="1024">
        <template v-slot:activator="{ props }">
          <v-btn v-bind="props"> New Member </v-btn>
        </template>
        <v-card style="background-color: #fff5e8">
          <v-card-title>
            <span class="text-h5">New Member</span>
          </v-card-title>
          <v-card-text>
            <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
              <v-container>
                <v-row>
                  <v-col cols="12" sm="12" md="4">
                    <v-text-field v-model="memberStore.editedMember.fristName" :readonly="loading"
                      :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                      label="FristName"></v-text-field>
                  </v-col>
                  <v-col cols="12" sm="12" md="4">
                    <v-text-field v-model="memberStore.editedMember.lastName" :readonly="loading"
                      :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                      label="LastName"></v-text-field>
                  </v-col>
                  <v-col cols="12" sm="12" md="4">
                    <v-text-field v-model="memberStore.editedMember.tel" :readonly="loading"
                      :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable label="Tel"></v-text-field>
                  </v-col>
                  <v-col cols="12" sm="12" md="4">
                    <v-text-field v-model="memberStore.editedMember.email" :readonly="loading"
                      :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable label="Email"></v-text-field>
                  </v-col>
                  <v-col cols="12" sm="12" md="4">
                    <v-text-field v-model="memberStore.editedMember.birth" :readonly="loading"
                      :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable label="date"
                      type="Date"></v-text-field>
                  </v-col>
                </v-row>
                <v-row justify="center"> </v-row>
              </v-container>
            </v-form>
          </v-card-text>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn variant="text" @click="closeDialog()"> Close </v-btn>
            <v-btn variant="text" @click="save()"> Save </v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>

      <!-- Delete Dialog-->
      <v-dialog v-model="dialogDelete" max-width="500px">
        <v-card>
          <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn variant="text" @click="closeDelete">Cancel</v-btn>
            <v-btn variant="text" @click="deleteItemConfirm">OK</v-btn>
            <v-spacer></v-spacer>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </v-toolbar>
    <v-table fixed-header height="530">
      <thead>
        <tr>
          <th>ID</th>
          <th>Name</th>
          <th>Tel</th>
          <th>Point</th>
          <th>Actions</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="item in memberStore.members" :key="item.id">
          <td>{{ item.id }}</td>
          <td>{{ item.fristName }}</td>
          <td>{{ item.tel }}</td>
          <td>{{ item.point }}</td>
          <td>
            <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
            <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
          </td>
        </tr>
      </tbody>
    </v-table>
  </v-container>
</template>

<style scoped>
.v-sheet {
  background-color: #fff5e8;
}

.v-toolbar {
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
  background-color: #ab9283;
}

.v-toolbar-title {
  font-weight: bold;
  font-size: 24px;
  color: white;
}

.v-table {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  text-decoration: none;
  background-color: #fff5e8;
}

.v-btn {
  background-color: #ffcb5e;
  border-radius: 80px;
  display: flex;
  justify-content: center;
  align-items: center;
  color: black;
}

.custom-header {
  background-color: #ffcb5e;
}
</style>
